#ifndef HACKS_H
#define HACKS_H

#define KDECORE_EXPORT
#define KDEUI_EXPORT
#define KDE_DEPRECATED
#define Q_WS_X11

#define kWarning(a) qDebug()

#include <qcoreapplication.h>
#include <qrect.h>
#include <X11/Xlib.h>
#include <fixx11h.h>
#include <stdio.h>
#include <stdlib.h>

Display* display();
Window rootWindow();

class QDesktopWidget
    {
    public:
        static int width() { return XDisplayWidth( display(), DefaultScreen( display())); }
        static int height() { return XDisplayHeight( display(), DefaultScreen( display())); }
        static QSize size() { return QSize( width(), height()); }
    };

class QWidget
    {
    public:
        QWidget( int ) {}
        static unsigned long winId() { return 0; }
    };

class QApplication
    {
    public:
        static QDesktopWidget* desktop() { abort(); }
        static QApplication* self() { abort(); }
        static QWidget* activeWindow() { abort(); }
    };

class QX11Info
    {
    public:
        static Display* display() { return ::display(); }
        static unsigned long appTime() { return CurrentTime; }
        static unsigned long appUserTime() { return CurrentTime; }
        static unsigned long appRootWindow() { return rootWindow(); }
        static int screen() { return DefaultScreen( display()); }
    };

typedef QString QCString;

#undef qApp
#define qApp QApplication::self()

#endif
